import { isLayout, mapStateToLayoutProps, rankWith } from '@jsonforms/core';
import { html, repeat, when } from '@microsoft/fast-element';
import { LAYOUT_RANK } from './RenderersRanks';
export const layoutLabelTemplate = html `
  ${when((x) => x.control.label, html `
      <div style="color: var(--neutral-foreground-hint);">${(x) => x.control.label}</div>
    `)}
`;
export const LayoutRendererTemplate = html `
  <template>
    <div>
      ${layoutLabelTemplate}
      ${repeat((x) => x.control.uischema.elements, html `
          <dispatch-renderer
            ?submitted=${(x, ctx) => ctx.parent.submitted}
            :dispatch=${(x, ctx) => ctx.parent.dispatch}
            :jsonforms=${(x, ctx) => ctx.parent.jsonforms}
            :prefix=${(x, ctx) => ctx.parent.prefix}
            :props=${(x, ctx) => ({
    uischema: x,
    schema: ctx.parent.control.schema,
    renderers: ctx.parent.control.renderers,
    path: ctx.parent.control.path,
    enabled: ctx.parent.control.enabled,
})}
          ></dispatch-renderer>
        `)}
    </div>
  </template>
`;
export const LayoutRendererEntry = {
    renderer: LayoutRendererTemplate,
    tester: rankWith(LAYOUT_RANK, isLayout),
    mapper: mapStateToLayoutProps,
};
